import java.awt.Point;
import java.awt.Rectangle;
import java.util.Random;


public class CircleThread implements Runnable {

	Circle circle;
	Drawing drawing;
	Thread thread;
	int waitTime;
	
	public CircleThread(Drawing d, Circle c, int waitTime){
		this.drawing = d;
		this.circle = c;
		this.waitTime = waitTime;
	}
	
	public void init(){
		thread = new Thread(this);
		thread.start();
	}
	
	public void run(){

		Random r = new Random();
		while(true)
		{	

			Rectangle bounds =  drawing.getBounds();
			
			Point topLeft, topRight, bottomLeft, bottomRight;
			
			topLeft =  new Point(bounds.x, bounds.y);
			topRight = new Point(bounds.x + bounds.width, bounds.y);
			
			bottomLeft =  new Point(bounds.x, bounds.y + bounds.height);
			bottomRight = new Point(bounds.x + bounds.width, bounds.y + bounds.height);

			if(this.circle.touchLine(topLeft, topRight)){
				circle.vDirection = Shape.DOWN;
				circle.hDirection = r.nextInt(2)+1;
			}
			else if(this.circle.touchLine(bottomLeft, bottomRight)){
				circle.vDirection = Shape.UP;
				circle.hDirection = r.nextInt(2)+1;
			}
			
			if(this.circle.touchLine(topLeft, bottomLeft)){
				circle.hDirection = Shape.RIGHT;
				circle.vDirection = r.nextInt(2)+3;
			}
			else if(this.circle.touchLine(topRight, bottomRight)){
				circle.hDirection = Shape.LEFT;
				circle.vDirection = r.nextInt(2)+3;
			}
			
			
			circle.move();
			//drawing.notifierLeListenerDeLaBalle();
			
			drawing.repaint();
			try{
				Thread.sleep(waitTime);
			}
			catch(InterruptedException e) {}
		}
		
	}

}
